/*
Copyright 2022 The orchest Authors.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/orchest/orchest/services/orchest-controller/pkg/apis/orchest/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// OrchestClusterLister helps list OrchestClusters.
// All objects returned here must be treated as read-only.
type OrchestClusterLister interface {
	// List lists all OrchestClusters in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.OrchestCluster, err error)
	// OrchestClusters returns an object that can list and get OrchestClusters.
	OrchestClusters(namespace string) OrchestClusterNamespaceLister
	OrchestClusterListerExpansion
}

// orchestClusterLister implements the OrchestClusterLister interface.
type orchestClusterLister struct {
	indexer cache.Indexer
}

// NewOrchestClusterLister returns a new OrchestClusterLister.
func NewOrchestClusterLister(indexer cache.Indexer) OrchestClusterLister {
	return &orchestClusterLister{indexer: indexer}
}

// List lists all OrchestClusters in the indexer.
func (s *orchestClusterLister) List(selector labels.Selector) (ret []*v1alpha1.OrchestCluster, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.OrchestCluster))
	})
	return ret, err
}

// OrchestClusters returns an object that can list and get OrchestClusters.
func (s *orchestClusterLister) OrchestClusters(namespace string) OrchestClusterNamespaceLister {
	return orchestClusterNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// OrchestClusterNamespaceLister helps list and get OrchestClusters.
// All objects returned here must be treated as read-only.
type OrchestClusterNamespaceLister interface {
	// List lists all OrchestClusters in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.OrchestCluster, err error)
	// Get retrieves the OrchestCluster from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.OrchestCluster, error)
	OrchestClusterNamespaceListerExpansion
}

// orchestClusterNamespaceLister implements the OrchestClusterNamespaceLister
// interface.
type orchestClusterNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all OrchestClusters in the indexer for a given namespace.
func (s orchestClusterNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.OrchestCluster, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.OrchestCluster))
	})
	return ret, err
}

// Get retrieves the OrchestCluster from the indexer for a given namespace and name.
func (s orchestClusterNamespaceLister) Get(name string) (*v1alpha1.OrchestCluster, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("orchestcluster"), name)
	}
	return obj.(*v1alpha1.OrchestCluster), nil
}
